#!/usr/bin/php
<?php

require_once '/var/www/api/init.php';
require_once '/var/www/common/wms_ldap.php';

$pbx         = \Models\PBX::getInstance();
$license     = \Wildix\License::getInstance();
$mailer      = \Wildix\SendEmail::getInstance();
$ldap        = \WMS_Ldap::getInstance();
$sslService  = new \Wildix\Services\SSL();
$log         = new \Syslog('SSLCertificateRenewal', \Syslog::DEBUG);
$certificate = new \Wildix\Certificate\SSLCertificate($sslService, $pbx, $license, $mailer, $ldap, $log);

$cliOptions = getopt('fc:i:s');

$attemptsCount   = isset($cliOptions['c']) ? $cliOptions['c'] : $certificate::DEFAULT_ATTEMPTS_COUNT;
$requestInterval = isset($cliOptions['i']) ? $cliOptions['i'] : $certificate::DEFAULT_REQUEST_INTERVAL;

$certificate->renew(isset($cliOptions['f']), $attemptsCount, $requestInterval, isset($cliOptions['s']));
