/**
 * Created with JetBrains PhpStorm.
 * User: kiragaz
 * Date: 11/7/12
 * Time: 12:43 PM
 * To change this template use File | Settings | File Templates.
 */
jQuery(document).ready( function ( $ ) {
	function getWairTableDataPrepaired () {
		var wairDataRaw = values.wair.BODY,
			wairData = [];

		$.each(wairDataRaw , function (index, dataRow) {
			var users = '',
				gateways = '',
				d = [];

			$.each(dataRow.nusers , function (index, user) {
				users+= user.username + ',';
			});

			$.each(dataRow.gateways , function (index, gateway) {
				d = [];
				if(gateway.desc){
					d.push(gateway.desc);
				}
				if(gateway.gwip){
					d.push(translation['strings.IpAddress'] + ': ' + gateway.gwip);
				}
				gateways+= '<span ' + ((d.length)?'title="' + d.join('<br>')  + '"':'') + '>' + gateway.gwid + '(' + gateway.type + ')' + '</span>,'
			});

			users = users.replace( /,+$/, '' );        //Removing trailing comas
			gateways = gateways.replace( /,+$/, '' );  //Removing trailing comas

			wairData.push({
				id: dataRow.nid,
				name: dataRow.name,
				gateways: gateways,
				users: users,
				code: dataRow.code,
				sipproxy: dataRow.sipproxy,
				primarybase: dataRow.primarybase,
				autodecttree: dataRow.autodecttree
			});
		});

		return wairData;
	}

	var wairUpdate = function () {

		var lastSelected = wairTable.rows({selected: true}).data();
		wairTable.ajax.reload(function(){
			if(lastSelected.length > 0){
				// set selected
				wairTable.rows(function(index, row, node){
					if(row.id){
						var result = $.grep(lastSelected, function(val){
							return row.id == val.id;
						});
						return result.length > 0;
					}
					return false;
				}).select();
			}

			if (lastSelected.length ) {
				$( '#editWAIRNetwork' ).button( 'enable' );
				$( '#removeWAIRNetwork' ).button( 'enable' );
			} else {
				$( '#editWAIRNetwork' ).button( 'disable' );
				$( '#removeWAIRNetwork' ).button( 'disable' );
			}

		}, false);
	};

	$(document).on('wairTable/update', wairUpdate);

	function populateGWList( network_id ) {
		ap_showWaitMessage('waitDiv', 1);
		$.post( 'devices/index.php', {"action":'getGWs', "network_id":network_id }, function ( data, textStatus ) {
			var availableBases = data['available'],
				selectedBases = data['selected'],
				$availableList = $( '#availableList' ),
				$selectedList = $( '#selectedList' );
			$( '#wairNetworkId' ).val( network_id );

			//Clearing lists
			$availableList.find( 'option' ).remove();
			$selectedList.find( 'option' ).remove();

			//Adding items to availableList
			$.each( availableBases, function ( index, oneBase ) {
				$availableList.append( $( '<option>', {
						value:oneBase,
						text:oneBase
					}
				));
			});

			//Adding items to availableList
			var firstItem = true;

			$.each( selectedBases, function ( index, oneBase ) {
				$selectedList.append( $( '<option>', {
						value:oneBase,
						text:oneBase + (firstItem ? '(M)' : '')
					}
				));

				firstItem = false;
			});
			ap_showWaitMessage('waitDiv', 0);
			$('#wairDialog').dialog('open');
			$('#wairMoveLeft').button().removeClass('ui-state-active ui-state-focus').show();
		});
	}

	var saveNetwork = function () {
		var selectedGateways = [],
			network_id = $('#wairNetworkId').val(),
			$nameInput = $('#wairNetworkName').focus(),
			$codeInput = $('#wairNetworkCode'),
			$nameError = $('#wairErrorNotifyName'),
			$codeError = $('#wairErrorNotifyCode'),
			name = $nameInput.val(),
			code = $codeInput.val(),
			error= false;
		$nameError.hide();
		$codeError.hide();

		// Name - cannot be empty
		if ( !name ) {
			$nameError.show();
			$nameInput.addClass( 'ui-state-error ' );

			error = true;
		} else {
			$nameError.hide();
			$nameInput.removeClass( 'ui-state-error ' );
		}

		// Code - must be exact 4 digits or empty
		if ( !/^\d{4}$/.test( code ) || code == '' ) {
			$codeError.show();
			$codeInput.addClass( 'ui-state-error ' );

			error = true;
		} else {
			$codeError.hide();
			$codeInput.removeClass( 'ui-state-error ' );
		}

		if (error){
			return;
		}

		$('#selectedList option').each(function(index, oneOption) {
			var value = $(oneOption).val();
			if(value != ''){
				selectedGateways.push(value);
			}
		});

		var dataPrepared = {
			"network_id":network_id,
			"name":name,
			"code":code,
			"sipproxy": $('#wairNetworkSipProxy').val(),
			"primarybase": $('#wairNetworkPrimaryBaseIP').val(),
			"autodecttree": ($('#autoDectTree').is(':checked') ? 1 : 0),
			"sel_gateways": selectedGateways
		};

		$.post( 'devices/index.php', {
			action: 'saveNetwork',
			data: dataPrepared
		}, function () {
			$( document ).trigger( 'devicesTable/update' );
			alert(translation['devices.ToApply']);
		});
		$(this).dialog("close");
	}

	var wairDialog = {};

	wairDialog[translation['buttons.Save']] = saveNetwork;
	wairDialog[translation['buttons.Cancel']] = function () {
		$(this).dialog("close");
	};


	$("#wairDialog").dialog({
		height:460,
		width:570,
		modal:true,
		resizable:false,
		autoOpen:false,
		open:function () {
			$( '#wairNetworkName' ).removeClass( 'ui-state-error ' );
			$( '#wairNetworkCode' ).removeClass( 'ui-state-error ' );

			$( '#wairErrorNotifyName' ).hide();
			$( '#wairErrorNotifyCode' ).hide();
		},

		buttons:wairDialog
	});

	var wairTable = $('#wairTable').DataTable({
		select: true,
		paging: true,
		pageLength: 25,
		searching: true,
		autoWidth: false,
		order: [[ 0, 'asc' ]],
		ajax: function ajax(data, callback, settings){
			callback({
				data: getWairTableDataPrepaired()
			});
		},
		columns: [ // column header
			{"data":"id", "title": translation['strings.ID'], width: '40px', className: "center", "orderable": true},
			{"data":"name", "title": translation['strings.Name'], "orderable": true},
			{"data":"gateways", "title": translation['devices.Gateways'], "orderable": true},
			{"data":"users", "title": translation['devices.GWUsers'], "orderable": false},
			{"data":"code", "title": translation['devices.Code'], "orderable": false, "visible": false},
			{"data":"sipproxy", "title": translation['devices.sipproxy'], "orderable": false, "visible": false},
			{"data":"primarybase", "title": translation['devices.primarybase'], "orderable": false, "visible": false},
			{"data":"autodecttree", "title": WMS._t('devices.autoDectTree'), "orderable": false, "visible": false},
		],
		data: getWairTableDataPrepaired(),
		language: dataTableLanguage,
		deferRender: true,
		dom: '<"dataTables_top"f>t<"dataTables_bottom"ip<"dataTables_buttons">l<"clear">>'
	}).on('dblclick', 'tbody tr', function(e){
		var tr = $(event.target);

		if(tr.hasClass('selected')){
			wairTable.rows(tr).deselect();
		}else{
			wairTable.rows(tr).select();
		}

		$('#editWAIRNetwork').button( 'enable' );
		$('#removeWAIRNetwork').button( 'enable' );
		$("#editWAIRNetwork").click();

    }).on('click', 'tbody tr', function ( e ) {
    	var selectedData = wairTable.rows({selected: true}).data()
		if (selectedData.length ) {
			$('#editWAIRNetwork').button('enable');
			$('#removeWAIRNetwork').button('enable');
		} else {
			$('#editWAIRNetwork').button('disable');
			$('#removeWAIRNetwork').button('disable');
		}
	});

	var wairTools = wairTable;


	//------------------------------------------
	var removeNetwork = function () {
		//if delete confirmed
		if (!ret_confirm_delete()) {
			return;
		}

		var selectedData = wairTable.rows({selected: true}).data();
		var network_ids = [];
		var dataPrepaired;

		$(selectedData).each(function(index, oneRow) {
			network_ids.push(oneRow.id);
		});

		$.post('devices/index.php',{
			action: 'deleteNetwork',
			data: {
				network_ids: network_ids
			}
		}, function (data) {
			$(document).trigger('devicesTable/update');
		});
	}

	$("#addWAIRNetwork").button( {icons:{primary:'ui-icon-plus', secondary:'ui-icon-newwin'}} )
		.next().button( {icons:{primary:'ui-icon-pencil', secondary:'ui-icon-newwin'}, disabled:true} )
		.next().button( {icons:{primary:'ui-icon-trash'}, text:false, disabled:true} ).on( "click", removeNetwork);

	$("#addWAIRNetwork, #editWAIRNetwork").on('click', function () {
		var selectedData = wairTable.rows({selected: true}).data(),
			networkId = this.id == 'addWAIRNetwork' ? 0 : selectedData[0].id,
			name = this.id == 'addWAIRNetwork' ? '' : selectedData[0].name,
			code = this.id == 'addWAIRNetwork' ? '0000' : selectedData[0].code,
			sipproxy = this.id == 'addWAIRNetwork' ? '' : selectedData[0].sipproxy,
			primarybase = this.id == 'addWAIRNetwork' ? '' : selectedData[0].primarybase;
			autodecttree = this.id == 'addWAIRNetwork' ? 1 : selectedData[0].autodecttree;

		$('#wairNetworkName').val(name);
		$('#wairNetworkCode').val(code);
		$('#wairNetworkSipProxy').val(sipproxy);
		$('#wairNetworkPrimaryBaseIP').val(primarybase);
		$('#autoDectTree').attr('checked', autodecttree == 0 ? false : true);
		$('#wairDialog').dialog( "option", "title", this.id == 'addWAIRNetwork' ? translation['devices.AddNetwork']: translation['devices.EditNetwork'] )
		populateGWList( networkId );

	});

	var moveRight = function () {
		var $availableList = $('#availableList'),
			$selectedList = $('#selectedList'),
			$selectedOptions = $availableList.find('option:selected');

		$selectedOptions.remove().appendTo($selectedList);

		$selectedList.find('option:first').html( function (index) {
			var text = $( this ).val();
			text += '(M)';
			return text;
		});
	}

	var moveLeft = function () {
		var $availableList = $( '#availableList' ),
			$selectedList = $( '#selectedList' ),
			$selectedOptions = $selectedList.find( 'option:selected' );

		$selectedOptions.remove().appendTo( $availableList ).html( function ( index ) {
			return $( this ).val();
		});

		$selectedList.find( 'option:first' ).html( function ( index ) {
			var text = $( this ).val();
			text += '(M)';
			return text;
		});
	}

	var moveUP = function () {
		var $selectedList = $( '#selectedList' ),
			$selectedOptions = $selectedList.find( 'option:selected' );

		$selectedOptions.each( function () {
			var $this = $( this ),
				$prev = $this.prev();

			$this.insertBefore( $prev );

			if ( $this.index() == 0 ) $this.html( $this.val() + '(' + 'M' + ')' );
			else $this.html( $this.val() );

			if ( $prev.index() == 0 ) $prev.html( $prev.val() + '(' + 'M' + ')' );
			else $prev.html( $prev.val() );

			$( this ).select();
		});
	}

	var moveDown = function () {
		var $selectedList = $( '#selectedList' ),
			$selectedOptions = $selectedList.find( 'option:selected' );

		$selectedOptions.each( function () {
			var $this = $( this ),
				$next = $this.next();

			$this.insertAfter( $next );

			if ( $this.index() == 0 ) $this.html( $this.val() + '(' + 'M' + ')' );
			else $this.html( $this.val() );

			if ( $next.index() == 0 ) $next.html( $next.val() + '(' + 'M' + ')' );
			else $next.html( $next.val() );

			$this.select();
		});
	}

	$('#availableList option').on('dblclick', moveRight);
	$('#selectedList option').on('dblclick', moveLeft);

	$( "#wairMoveLeft" ).button( {icons:{primary:'ui-icon-circle-arrow-w'}, text:false } ).on('click',moveLeft);
	$( "#wairMoveRight" ).button( {icons:{primary:'ui-icon-circle-arrow-e'}, text:false } ).on('click',moveRight);

	$( "#wairMoveUP" ).button( {icons:{primary:'ui-icon-circle-arrow-n'}, text:false } ).on('click', moveUP);
	$( "#wairMoveDown" ).button( {icons:{primary:'ui-icon-circle-arrow-s'}, text:false } ).on('click',moveDown);
});
