(function ($) { // To-do: remove after prototype removed
    var HttpProxySettings = function () {
        this.constructor();
    };

    HttpProxySettings.prototype = {
        constructor: function () {
            this.mainForm = $('#proxy_settings_form');
            this._data = false;
        },
        load: function () {
            this.mainForm.apiForm({
                load: 'api/v1/PBX/settings/httpProxy/',
                submit: 'api/v1/PBX/settings/httpProxy/',

                beforeSubmit: function () { ap_showWaitMessage('waitDiv', 1); },
                error: function (ajaxData) { setError('error', ajaxData.reason, 5000); },
                afterSubmit: function () {
                    ap_showWaitMessage('waitDiv', 0);
                    this._onChangeEnable();
                    this._data = this.mainForm.apiForm('option', 'loadData');
                }.bind(this)
            });

            this.mainForm.apiForm('load');

            this.mainForm.on('change', '#ps_proxy_enable', $.proxy(this._onChangeEnable, this));
            this.mainForm.on('click', '#saveSettings', function () {
                this.sendForm();
            }.bind(this));

            /* eslint-disable */
            $(window).bind('beforeunload', $.proxy(function(){
                if (this.isDirty()){
                    return WMS._t('prefs.are_you_sure_want_to_exit_without_save');
                }
            }, this));
            /* eslint-enable */
        },
        sendForm: function () {
            if (this.validateFormData()) {
                this.mainForm.apiForm('submit');
            }
        },
        getData: function () {
            var paramObj = {};
            $.each(this.mainForm.serializeArray(), function(_, kv) {
                paramObj[kv.name] = kv.value;
            });
            return paramObj;
        },
        isDirty: function(){
            var result = false;

            $.each(this.getData(), function(name, value){
                if(name === 'username' || name === 'pass') { // Skip for hacked fields
                    return;
                }
                if (this._data[name] !== value){
                    result = true;
                }
            }.bind(this));

            return result;
        },
        _onChangeEnable: function () {
            var els = ['host', 'port', 'auth_method', 'login', 'password'];
            if(this.mainForm.find('#ps_proxy_enable').prop('checked')){
                this.mainForm.find('#ps_proxy_enable').val(1);

                els.forEach(function (entry) {
                    $('[name="' + entry + '"]').prop('disabled', false);
                });
            } else {
                this.mainForm.find('#ps_proxy_enable').val(0);
                els.forEach(function (entry) {
                    $('[name="' + entry + '"]').prop('disabled', true);
                });
            }
        },
        validateFormData: function () {
            if (parseInt(this.mainForm.find('#ps_proxy_enable:checked').val())) {
                this.mainForm.checkForm({
                    rules: [
                        'required,host,' + WMS._t('rules.CannotBeEmpty'),
                        'required,port,' + WMS._t('rules.CannotBeEmpty'),
                        'if:port!=,range=1-65535,port,' + WMS._t('rules.enterValidValue') + ' 1-65535'
                    ]
                });
                return this.mainForm.checkForm('validate');
            }
            return true;
        }
    };

    $(document).ready(function () {
        new HttpProxySettings().load();
    });
})(jQuery);
